//+------------------------------------------------------------------+
//|                                              
//|                     
//|                                     
//+------------------------------------------------------------------+
//#define MAGICMA  1960//20050610
extern double MAGICMA = 1960;
extern string  = " :";
extern double Lots               = 1;
extern double MaximumRisk        = 0;
extern double DecreaseFactor     = 2;
extern double TakeProfit =17;
extern double StopLoss = 100;
extern string  = "Z-  K D P  :";
extern double Z = 2;
extern double K = 3;
extern double D = 3;
extern double P = 2;
extern double TrailingStop =5;
extern double UB = 10;
extern double US = 90;
extern int start=1;
                        


//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(MaximumRisk==0) lot=Lots;
   if(lot<0.01) lot=0.01;
   return(lot);
  }
// MODIFI


//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+


int babon(int x)
{
   static int trend1;
   double O = iOpen(NULL, 1, 0);
   double C = iClose(NULL, 1, 0);
   double C1 = iClose(NULL, 1, 1);
   double L1 = iLow(NULL, 5, 0);
   double H1 = iHigh(NULL, 5, 0);
 
   double KU = iCustom(NULL,1, "",20,20,Z, 0, 0);
   double KL = iCustom(NULL,1, "",20,20,Z, 2, 0);
   double KU1 = iCustom(NULL,1, "",20,20,Z, 0, 1);
   double KL1 = iCustom(NULL,1, "",20,20,2, 2, 1);
   double KM1 = iCustom(NULL,1, "",20,20,Z, 1, 1);
   
   double KU5 = iCustom(NULL, 5, "",20,20,Z, 0, 0);
   double KL5 = iCustom(NULL, 5, "",20,20,Z, 2, 0);
   double KM5 = iCustom(NULL, 5, "",20,20,Z, 1, 0);
   

   double S = iStochastic(NULL,1,K,D,P, MODE_SMA, 0, MODE_MAIN,0);  
   double S1 = iStochastic(NULL,1,K,D,P, MODE_SMA, 0, MODE_MAIN,1);
   double S2 = iStochastic(NULL,1,K,D,P, MODE_SMA, 0, MODE_MAIN,2);
   double S3 = iStochastic(NULL,1,K,D,P, MODE_SMA, 0, MODE_MAIN,3);
   double SI = iStochastic(NULL,1,K,D,P, MODE_SMA, 0, MODE_SIGNAL,0);
   double SI1 = iStochastic(NULL,1,K,D,P, MODE_SMA, 0, MODE_SIGNAL,1);
   double SI2 = iStochastic(NULL,1,K,D,P, MODE_SMA, 0, MODE_SIGNAL,2); 
   
   double TH = iStochastic(NULL,5,K,D,P, MODE_SMA, 0, MODE_SIGNAL,0);
   double TH1 = iStochastic(NULL,5,K,D,P, MODE_SMA, 0, MODE_SIGNAL,1);
   
 
   
   int trend = trend1;
   
        if (L1<KL1&&SI>SI1&&SI1<SI2&&SI1<UB&&TH>=TH1) trend =1;
        if (H1>KU1&&SI<SI1&&SI1>SI2&&SI1>US&&TH<=TH1) trend =-1;
        return (trend);

}


void CheckForOpen()
  {
   double ma,SL,TP,ticket;
   int    res;
//---- go trading only for first tiks of new bar
 // if(Volume[0]>1) return;
 


     
  int trend = babon(start);


   if(trend==-1)  
     {
      RefreshRates();
         SL = Ask + StopLoss * Point;
         TP = Ask - TakeProfit * Point;
      res=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,3,SL,TP,"",MAGICMA,0,Red);
      return;
     }
//---- buy conditions
 
   if(trend==1)
     {
     RefreshRates();
         SL = Bid - StopLoss * Point;
         TP = Bid+TakeProfit*Point;
      res=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,SL,TP,"",MAGICMA,0,Blue);
      return;
     }

  }
// MODIFI
 

 

//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double TS = TrailingStop;
   double R = Ask -Bid ;
//---- go trading only for first tiks of new bar
  
   if(TrailingStop < R) TS = R*Point ;

   int trend=babon(start);
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY&&TS > 0&&Bid - OrderOpenPrice() >= TS* Point)
        {
         OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TS,
                        OrderClosePrice() + OrderTakeProfit() * Point + TS * Point, 0, CLR_NONE);
  
         if(trend ==-1) OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
         break;
        }
       
      if(OrderType()==OP_SELL&&TS > 0&&OrderOpenPrice() - Ask >= TS* Point)
        {
        OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TS, 
                        OrderClosePrice() - OrderTakeProfit() * Point - TS * Point, 0, CLR_NONE);
         
         if(trend ==1) OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
         break;
        }
     }
//----
  }
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {

   if(start!=0) 
  
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else                                    CheckForClose();
//----
  }
//+------------------------------------------------------------------+